Index: /trunk/sources/HeuristicLab.Common/3.2/HeuristicLab.Common-3.2.csproj
===================================================================
--- /trunk/sources/HeuristicLab.Common/3.2/HeuristicLab.Common-3.2.csproj	(revision 2738)
+++ /trunk/sources/HeuristicLab.Common/3.2/HeuristicLab.Common-3.2.csproj	(revision 2739)
@@ -84,4 +84,5 @@
   <ItemGroup>
     <Compile Include="CancelEventArgs.cs" />
+    <Compile Include="TypeExtensions.cs" />
     <Compile Include="ObservableList.cs" />
     <Compile Include="DoubleExtensions.cs">
Index: /trunk/sources/HeuristicLab.Common/3.2/TypeExtensions.cs
===================================================================
--- /trunk/sources/HeuristicLab.Common/3.2/TypeExtensions.cs	(revision 2739)
+++ /trunk/sources/HeuristicLab.Common/3.2/TypeExtensions.cs	(revision 2739)
@@ -0,0 +1,48 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Text;
+
+namespace HeuristicLab.Common {
+  public static class TypeExtensions {
+    public static string GetPrettyName(this Type x) {
+      return x.GetPrettyName(false);
+    }
+    public static string GetPrettyName(this Type x, bool includeNamespace) {
+      StringBuilder sb = new StringBuilder();
+      if ((includeNamespace) && !string.IsNullOrEmpty(x.Namespace))
+        sb.Append(x.Namespace).Append(".");
+      sb.Append(x.Name);
+      if (x.IsGenericType) {
+        Type[] genericParams = x.GetGenericArguments();
+        sb.Remove(sb.ToString().LastIndexOf('`'), genericParams.Length.ToString().Length + 1);
+        sb.Append("<");
+        for (int i = 0; i < genericParams.Length; i++) {
+          if (i > 0) sb.Append(", ");
+          sb.Append(genericParams[i].GetPrettyName(includeNamespace));
+        }
+        sb.Append(">");
+      }
+      return sb.ToString();
+    }
+  }
+}
Index: /trunk/sources/HeuristicLab.Core.Views/3.3/TypeSelector.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core.Views/3.3/TypeSelector.cs	(revision 2738)
+++ /trunk/sources/HeuristicLab.Core.Views/3.3/TypeSelector.cs	(revision 2739)
@@ -28,4 +28,5 @@
 using System.Windows.Forms;
 using System.Linq;
+using HeuristicLab.Common;
 using HeuristicLab.PluginInfrastructure;
 using HeuristicLab.MainForm;
@@ -113,5 +114,5 @@
               TreeNode typeNode = new TreeNode();
               string name = ItemAttribute.GetName(type);
-              typeNode.Text = name != null ? name : type.Name;
+              typeNode.Text = name != null ? name : type.GetPrettyName();
               typeNode.ImageIndex = 0;
               if (type.IsInterface) typeNode.ImageIndex = 2;
@@ -138,5 +139,5 @@
         }
         if (typesTreeView.Nodes.Count == 0) {
-          typesTreeView.Nodes.Add("No types of base type \"" + BaseType.Name + "\" found");
+          typesTreeView.Nodes.Add("No types of base type \"" + BaseType.GetPrettyName() + "\" found");
           typesTreeView.Enabled = false;
         }
Index: /trunk/sources/HeuristicLab.Core.Views/3.3/ViewHost.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core.Views/3.3/ViewHost.cs	(revision 2738)
+++ /trunk/sources/HeuristicLab.Core.Views/3.3/ViewHost.cs	(revision 2739)
@@ -28,4 +28,5 @@
 using System.Windows.Forms;
 using System.Linq;
+using HeuristicLab.Common;
 using HeuristicLab.MainForm;
 
@@ -68,7 +69,7 @@
                         select t;
         foreach (Type viewType in viewTypes) {
-          ToolStripMenuItem item = new ToolStripMenuItem(viewType.Name);
+          ToolStripMenuItem item = new ToolStripMenuItem(viewType.GetPrettyName());
           item.Name = viewType.FullName;
-          item.ToolTipText = viewType.FullName;
+          item.ToolTipText = viewType.GetPrettyName(true);
           item.Tag = viewType;
           contextMenuStrip.Items.Add(item);