Index: trunk/sources/HeuristicLab.GP.Algorithms/3.2/HeuristicLab.GP.Algorithms-3.2.csproj
===================================================================
--- trunk/sources/HeuristicLab.GP.Algorithms/3.2/HeuristicLab.GP.Algorithms-3.2.csproj	(revision 2728)
+++ trunk/sources/HeuristicLab.GP.Algorithms/3.2/HeuristicLab.GP.Algorithms-3.2.csproj	(revision 2750)
@@ -83,4 +83,5 @@
   <ItemGroup>
     <Compile Include="AlgorithmBase.cs" />
+    <None Include="HeuristicLabGpAlgorithmsPlugin.cs.frame" />
     <Compile Include="HeuristicLabGpAlgorithmsPlugin.cs" />
     <Compile Include="OffspringSelectionGP.cs">
@@ -186,5 +187,6 @@
 set Outdir=$(Outdir)
 
-call PreBuildEvent.cmd</PreBuildEvent>
+call PreBuildEvent.cmd
+SubWCRev "%25ProjectDir%25/" "%25ProjectDir%25/HeuristicLabGPAlgorithmsPlugin.cs.frame" "%25ProjectDir%25/HeuristicLabGPAlgorithmsPlugin.cs"</PreBuildEvent>
   </PropertyGroup>
 </Project>
Index: trunk/sources/HeuristicLab.GP.Algorithms/3.2/HeuristicLabGpAlgorithmsPlugin.cs
===================================================================
--- trunk/sources/HeuristicLab.GP.Algorithms/3.2/HeuristicLabGpAlgorithmsPlugin.cs	(revision 2728)
+++ trunk/sources/HeuristicLab.GP.Algorithms/3.2/HeuristicLabGpAlgorithmsPlugin.cs	(revision 2750)
@@ -26,5 +26,5 @@
 
 namespace HeuristicLab.GP.Algorithms {
-  [Plugin("HeuristicLab.GP.Algorithms-3.2")]
+  [Plugin("HeuristicLab.GP.Algorithms", "3.3.0.2728")]
   [PluginFile("HeuristicLab.GP.Algorithms-3.2.dll", PluginFileType.Assembly)]
   [PluginDependency("HeuristicLab.Common-3.2")]
@@ -32,7 +32,7 @@
   [PluginDependency("HeuristicLab.Data-3.2")]
   [PluginDependency("HeuristicLab.Evolutionary-3.2")]
-  [PluginDependency("HeuristicLab.GP-3.3")]
-  [PluginDependency("HeuristicLab.GP.Interfaces-3.3")]
-  [PluginDependency("HeuristicLab.GP.Operators-3.3")]
+  [PluginDependency("HeuristicLab.GP", "3.3")]
+  [PluginDependency("HeuristicLab.GP.Interfaces", "3.3")]
+  [PluginDependency("HeuristicLab.GP.Operators", "3.3")]
   [PluginDependency("HeuristicLab.Logging-3.2")]
   [PluginDependency("HeuristicLab.Operators-3.2")]
Index: trunk/sources/HeuristicLab.GP.Algorithms/3.2/HeuristicLabGpAlgorithmsPlugin.cs.frame
===================================================================
--- trunk/sources/HeuristicLab.GP.Algorithms/3.2/HeuristicLabGpAlgorithmsPlugin.cs.frame	(revision 2750)
+++ trunk/sources/HeuristicLab.GP.Algorithms/3.2/HeuristicLabGpAlgorithmsPlugin.cs.frame	(revision 2750)
@@ -0,0 +1,45 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Text;
+using HeuristicLab.PluginInfrastructure;
+
+namespace HeuristicLab.GP.Algorithms {
+  [Plugin("HeuristicLab.GP.Algorithms", "3.3.0.$WCREV$")]
+  [PluginFile("HeuristicLab.GP.Algorithms-3.2.dll", PluginFileType.Assembly)]
+  [PluginDependency("HeuristicLab.Common-3.2")]
+  [PluginDependency("HeuristicLab.Core-3.2")]
+  [PluginDependency("HeuristicLab.Data-3.2")]
+  [PluginDependency("HeuristicLab.Evolutionary-3.2")]
+  [PluginDependency("HeuristicLab.GP", "3.3")]
+  [PluginDependency("HeuristicLab.GP.Interfaces", "3.3")]
+  [PluginDependency("HeuristicLab.GP.Operators", "3.3")]
+  [PluginDependency("HeuristicLab.Logging-3.2")]
+  [PluginDependency("HeuristicLab.Operators-3.2")]
+  [PluginDependency("HeuristicLab.Random-3.2")]
+  [PluginDependency("HeuristicLab.Selection-3.2")]
+  [PluginDependency("HeuristicLab.Selection.OffspringSelection-3.2")]
+  [PluginDependency("HeuristicLab.SequentialEngine-3.2")]
+  public class HeuristicLabGpAlgorithmsPlugin : PluginBase {
+  }
+}
Index: trunk/sources/HeuristicLab.GP.Algorithms/3.2/Properties/AssemblyInfo.frame
===================================================================
--- trunk/sources/HeuristicLab.GP.Algorithms/3.2/Properties/AssemblyInfo.frame	(revision 2728)
+++ trunk/sources/HeuristicLab.GP.Algorithms/3.2/Properties/AssemblyInfo.frame	(revision 2750)
@@ -23,5 +23,4 @@
 using System.Runtime.CompilerServices;
 using System.Runtime.InteropServices;
-using HeuristicLab.PluginInfrastructure;
 
 // General Information about an assembly is controlled through the following 
@@ -33,5 +32,5 @@
 [assembly: AssemblyCompany("")]
 [assembly: AssemblyProduct("HeuristicLab")]
-[assembly: AssemblyCopyright("(c) 2002-2008 HEAL")]
+[assembly: AssemblyCopyright("(c) 2002-2010 HEAL")]
 [assembly: AssemblyTrademark("")]
 [assembly: AssemblyCulture("")]
@@ -54,5 +53,4 @@
 // You can specify all the values or you can default the Revision and Build Numbers 
 // by using the '*' as shown below:
-[assembly: AssemblyVersion("3.2.0.$WCREV$")]
+[assembly: AssemblyVersion("3.2.0.0")]
 [assembly: AssemblyFileVersion("3.2.0.$WCREV$")]
-[assembly: AssemblyBuildDate("$WCNOW$")]