Index: /trunk/sources/HeuristicLab.AdvancedOptimizationFrontend/3.2/HeuristicLabAdvancedOptimizationFrontendPlugin.cs
===================================================================
--- /trunk/sources/HeuristicLab.AdvancedOptimizationFrontend/3.2/HeuristicLabAdvancedOptimizationFrontendPlugin.cs	(revision 2757)
+++ /trunk/sources/HeuristicLab.AdvancedOptimizationFrontend/3.2/HeuristicLabAdvancedOptimizationFrontendPlugin.cs	(revision 2758)
@@ -33,5 +33,5 @@
   [PluginFile("HeuristicLab.AdvancedOptimizationFrontend-3.2.dll", PluginFileType.Assembly)]
   [PluginDependency("HeuristicLab.Core-3.2")]
-  [PluginDependency("HeuristicLab.WinFormsUI-2.3.1")]
+  [PluginDependency("HeuristicLab.WinFormsUI", "2.3.1.0")]
   public class HeuristicLabAdvancedOptimizationFrontendPlugin : PluginBase {
   }
Index: /trunk/sources/HeuristicLab.CEDMA.Server/3.3/HeuristicLabCedmaServerPlugin.cs
===================================================================
--- /trunk/sources/HeuristicLab.CEDMA.Server/3.3/HeuristicLabCedmaServerPlugin.cs	(revision 2757)
+++ /trunk/sources/HeuristicLab.CEDMA.Server/3.3/HeuristicLabCedmaServerPlugin.cs	(revision 2758)
@@ -36,5 +36,5 @@
   [PluginDependency("HeuristicLab.Modeling.Database-3.2")]
   [PluginDependency("HeuristicLab.Modeling.Database.SQLServerCompact-3.2")]
-  [PluginDependency("HeuristicLab.Tracing-3.2")]
+  [PluginDependency("HeuristicLab.Tracing","3.2.0.0")]
   public class HeuristicLabCedmaServerPlugin : PluginBase {
   }
Index: /trunk/sources/HeuristicLab.CodeEditor/3.2/HeuristicLabCodeEditorPlugin.cs
===================================================================
--- /trunk/sources/HeuristicLab.CodeEditor/3.2/HeuristicLabCodeEditorPlugin.cs	(revision 2757)
+++ /trunk/sources/HeuristicLab.CodeEditor/3.2/HeuristicLabCodeEditorPlugin.cs	(revision 2758)
@@ -9,5 +9,5 @@
   [Plugin("HeuristicLab.CodeEditor-3.2")]
   [PluginFile("HeuristicLab.CodeEditor-3.2.dll", PluginFileType.Assembly)]
-  [PluginDependency("HeuristicLab.Common.Resources-3.2")]
+  [PluginDependency("HeuristicLab.Common.Resources","3.2.0.0")]
   [PluginDependency("HeuristicLab.SharpDevelop-3.1.1.5327")]
   public class HeuristicLabCodeEditorPlugin : PluginBase {
Index: /trunk/sources/HeuristicLab.Communication.Data/3.2/HeuristicLabCommunicationDataPlugin.cs
===================================================================
--- /trunk/sources/HeuristicLab.Communication.Data/3.2/HeuristicLabCommunicationDataPlugin.cs	(revision 2757)
+++ /trunk/sources/HeuristicLab.Communication.Data/3.2/HeuristicLabCommunicationDataPlugin.cs	(revision 2758)
@@ -28,5 +28,5 @@
   [Plugin("HeuristicLab.Communication.Data-3.2")]
   [PluginFile("HeuristicLab.Communication.Data-3.2.dll", PluginFileType.Assembly)]
-  [PluginDependency("HeuristicLab.Common-3.2")]
+  [PluginDependency("HeuristicLab.Common","3.2.0.0")]
   [PluginDependency("HeuristicLab.Core-3.2")]
   [PluginDependency("HeuristicLab.Data-3.2")]
Index: /trunk/sources/HeuristicLab.Core/3.2/HeuristicLabCorePlugin.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core/3.2/HeuristicLabCorePlugin.cs	(revision 2757)
+++ /trunk/sources/HeuristicLab.Core/3.2/HeuristicLabCorePlugin.cs	(revision 2758)
@@ -32,5 +32,5 @@
   [Plugin("HeuristicLab.Core-3.2", "3.2.0.0")]
   [PluginFile("HeuristicLab.Core-3.2.dll", PluginFileType.Assembly)]
-  [PluginDependency("HeuristicLab.Common-3.2")]
+  [PluginDependency("HeuristicLab.Common","3.2.0.0")]
   public class HeuristicLabCorePlugin : PluginBase {
   }
Index: /trunk/sources/HeuristicLab.Core/3.2/ScopeView.Designer.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core/3.2/ScopeView.Designer.cs	(revision 2757)
+++ /trunk/sources/HeuristicLab.Core/3.2/ScopeView.Designer.cs	(revision 2758)
@@ -32,8 +32,4 @@
     /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
     protected override void Dispose(bool disposing) {
-      if (scopesTreeView.Nodes.Count > 0) {
-        RemoveTreeNode(scopesTreeView.Nodes[0]);
-        scopesTreeView.Nodes.Clear();
-      }
       if (disposing && (components != null)) {
         components.Dispose();
Index: /trunk/sources/HeuristicLab.Data/3.2/HeuristicLabDataPlugin.cs
===================================================================
--- /trunk/sources/HeuristicLab.Data/3.2/HeuristicLabDataPlugin.cs	(revision 2757)
+++ /trunk/sources/HeuristicLab.Data/3.2/HeuristicLabDataPlugin.cs	(revision 2758)
@@ -31,5 +31,5 @@
   [Plugin("HeuristicLab.Data-3.2")]
   [PluginFile("HeuristicLab.Data-3.2.dll", PluginFileType.Assembly)]
-  [PluginDependency("HeuristicLab.Common-3.2")]
+  [PluginDependency("HeuristicLab.Common","3.2.0.0")]
   [PluginDependency("HeuristicLab.Core-3.2")]
   public class HeuristicLabDataPlugin : PluginBase {
Index: /trunk/sources/HeuristicLab.ES/3.2/HeuristicLabESPlugin.cs
===================================================================
--- /trunk/sources/HeuristicLab.ES/3.2/HeuristicLabESPlugin.cs	(revision 2757)
+++ /trunk/sources/HeuristicLab.ES/3.2/HeuristicLabESPlugin.cs	(revision 2758)
@@ -31,5 +31,5 @@
   [Plugin("HeuristicLab.ES-3.2")]
   [PluginFile("HeuristicLab.ES-3.2.dll", PluginFileType.Assembly)]
-  [PluginDependency("HeuristicLab.Common-3.2")]
+  [PluginDependency("HeuristicLab.Common","3.2.0.0")]
   [PluginDependency("HeuristicLab.Core-3.2")]
   [PluginDependency("HeuristicLab.Data-3.2")]
Index: /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.SharpDevelop/3.1.1.5327/HeuristicLabSharpDevelopPlugin.cs
===================================================================
--- /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.SharpDevelop/3.1.1.5327/HeuristicLabSharpDevelopPlugin.cs	(revision 2757)
+++ /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.SharpDevelop/3.1.1.5327/HeuristicLabSharpDevelopPlugin.cs	(revision 2758)
@@ -14,5 +14,5 @@
   [PluginFile("Mono License.txt", PluginFileType.License)]
   [PluginFile("SharpDevelop License.txt", PluginFileType.License)]
-  [PluginDependency("HeuristicLab.log4net-1.2.10.0")]
+  [PluginDependency("HeuristicLab.log4net","1.2.10.0")]
   public class HeuristicLabSharpDevelopPlugin : PluginBase {
   }
Index: /trunk/sources/HeuristicLab.GP.Algorithms/3.2/HeuristicLabGpAlgorithmsPlugin.cs.frame
===================================================================
--- /trunk/sources/HeuristicLab.GP.Algorithms/3.2/HeuristicLabGpAlgorithmsPlugin.cs.frame	(revision 2757)
+++ /trunk/sources/HeuristicLab.GP.Algorithms/3.2/HeuristicLabGpAlgorithmsPlugin.cs.frame	(revision 2758)
@@ -28,5 +28,5 @@
   [Plugin("HeuristicLab.GP.Algorithms", "3.3.0.$WCREV$")]
   [PluginFile("HeuristicLab.GP.Algorithms-3.2.dll", PluginFileType.Assembly)]
-  [PluginDependency("HeuristicLab.Common-3.2")]
+  [PluginDependency("HeuristicLab.Common","3.2.0.0")]
   [PluginDependency("HeuristicLab.Core-3.2")]
   [PluginDependency("HeuristicLab.Data-3.2")]
Index: /trunk/sources/HeuristicLab.GP.Boolean/3.3/HeuristicLabGPBooleanPlugin.cs
===================================================================
--- /trunk/sources/HeuristicLab.GP.Boolean/3.3/HeuristicLabGPBooleanPlugin.cs	(revision 2757)
+++ /trunk/sources/HeuristicLab.GP.Boolean/3.3/HeuristicLabGPBooleanPlugin.cs	(revision 2758)
@@ -28,5 +28,5 @@
   [Plugin("HeuristicLab.GP.Boolean-3.3")]
   [PluginFile("HeuristicLab.GP.Boolean-3.3.dll", PluginFileType.Assembly)]
-  [PluginDependency("HeuristicLab.Common-3.2")]
+  [PluginDependency("HeuristicLab.Common","3.2.0.0")]
   [PluginDependency("HeuristicLab.Core-3.2")]
   [PluginDependency("HeuristicLab.Data-3.2")]
Index: /trunk/sources/HeuristicLab.GP.StructureIdentification.Classification/3.3/HeuristicLabGPClassificationPlugin.cs
===================================================================
--- /trunk/sources/HeuristicLab.GP.StructureIdentification.Classification/3.3/HeuristicLabGPClassificationPlugin.cs	(revision 2757)
+++ /trunk/sources/HeuristicLab.GP.StructureIdentification.Classification/3.3/HeuristicLabGPClassificationPlugin.cs	(revision 2758)
@@ -28,5 +28,5 @@
   [Plugin("HeuristicLab.GP.StructureIdentification.Classification-3.3")]
   [PluginFile("HeuristicLab.GP.StructureIdentification.Classification-3.3.dll", PluginFileType.Assembly)]
-  [PluginDependency("HeuristicLab.Common-3.2")]
+  [PluginDependency("HeuristicLab.Common","3.2.0.0")]
   [PluginDependency("HeuristicLab.Core-3.2")]
   [PluginDependency("HeuristicLab.Data-3.2")]
Index: /trunk/sources/HeuristicLab.GP.StructureIdentification.Networks/3.2/HeuristicLabGPStructureIdentificationNetworksPlugin.cs
===================================================================
--- /trunk/sources/HeuristicLab.GP.StructureIdentification.Networks/3.2/HeuristicLabGPStructureIdentificationNetworksPlugin.cs	(revision 2757)
+++ /trunk/sources/HeuristicLab.GP.StructureIdentification.Networks/3.2/HeuristicLabGPStructureIdentificationNetworksPlugin.cs	(revision 2758)
@@ -28,5 +28,5 @@
   [Plugin("HeuristicLab.GP.StructureIdentification.Networks-3.2")]
   [PluginFile("HeuristicLab.GP.StructureIdentification.Networks-3.2.dll", PluginFileType.Assembly)]
-  [PluginDependency("HeuristicLab.Common-3.2")]
+  [PluginDependency("HeuristicLab.Common","3.2.0.0")]
   [PluginDependency("HeuristicLab.Core-3.2")]
   [PluginDependency("HeuristicLab.Data-3.2")]
Index: /trunk/sources/HeuristicLab.GP.StructureIdentification/3.3/HeuristicLabGPStructureIdentificationPlugin.cs.frame
===================================================================
--- /trunk/sources/HeuristicLab.GP.StructureIdentification/3.3/HeuristicLabGPStructureIdentificationPlugin.cs.frame	(revision 2757)
+++ /trunk/sources/HeuristicLab.GP.StructureIdentification/3.3/HeuristicLabGPStructureIdentificationPlugin.cs.frame	(revision 2758)
@@ -25,5 +25,5 @@
   [Plugin("HeuristicLab.GP.StructureIdentification", "3.3.0.$WCREV$")]
   [PluginFile("HeuristicLab.GP.StructureIdentification-3.3.dll", PluginFileType.Assembly)]
-  [PluginDependency("HeuristicLab.Common-3.2")]
+  [PluginDependency("HeuristicLab.Common","3.2.0.0")]
   [PluginDependency("HeuristicLab.Core-3.2")]
   [PluginDependency("HeuristicLab.Data-3.2")]
Index: /trunk/sources/HeuristicLab.Grid.HiveBridge/3.2/HeuristicLabGridHiveBridgePlugin.cs
===================================================================
--- /trunk/sources/HeuristicLab.Grid.HiveBridge/3.2/HeuristicLabGridHiveBridgePlugin.cs	(revision 2757)
+++ /trunk/sources/HeuristicLab.Grid.HiveBridge/3.2/HeuristicLabGridHiveBridgePlugin.cs	(revision 2758)
@@ -33,5 +33,5 @@
   [PluginDependency("HeuristicLab.Hive.JobBase-3.2")]
   [PluginDependency("HeuristicLab.Hive.Engine-3.2")]
-  [PluginDependency("HeuristicLab.Tracing-3.2")]
+  [PluginDependency("HeuristicLab.Tracing","3.2.0.0")]
   public class HeuristicLabGridPlugin : PluginBase {
   }
Index: /trunk/sources/HeuristicLab.Grid/3.2/HeuristicLabGridPlugin.cs
===================================================================
--- /trunk/sources/HeuristicLab.Grid/3.2/HeuristicLabGridPlugin.cs	(revision 2757)
+++ /trunk/sources/HeuristicLab.Grid/3.2/HeuristicLabGridPlugin.cs	(revision 2758)
@@ -30,5 +30,5 @@
   [PluginFile("HeuristicLab.Grid-3.2.dll", PluginFileType.Assembly)]
   [PluginDependency("HeuristicLab.Core-3.2")]
-  [PluginDependency("HeuristicLab.Tracing-3.2")]
+  [PluginDependency("HeuristicLab.Tracing", "3.2.0.0")]
   [PluginDependency("HeuristicLab.SQLite-1.0.65.0")]
   public class HeuristicLabGridPlugin : PluginBase {
Index: /trunk/sources/HeuristicLab.Hive.Client.Common/3.2/CommonPlugin.cs
===================================================================
--- /trunk/sources/HeuristicLab.Hive.Client.Common/3.2/CommonPlugin.cs	(revision 2757)
+++ /trunk/sources/HeuristicLab.Hive.Client.Common/3.2/CommonPlugin.cs	(revision 2758)
@@ -31,5 +31,5 @@
   [PluginDependency("HeuristicLab.Core-3.2")]
   [PluginDependency("HeuristicLab.Hive.Contracts-3.2")]
-  [PluginDependency("HeuristicLab.Tracing-3.2")]
+  [PluginDependency("HeuristicLab.Tracing","3.2.0.0")]
   public class CommonPlugin: PluginBase {
   }
Index: /trunk/sources/HeuristicLab.Hive.Engine/3.2/HeuristicLabHiveEnginePlugin.cs
===================================================================
--- /trunk/sources/HeuristicLab.Hive.Engine/3.2/HeuristicLabHiveEnginePlugin.cs	(revision 2757)
+++ /trunk/sources/HeuristicLab.Hive.Engine/3.2/HeuristicLabHiveEnginePlugin.cs	(revision 2758)
@@ -31,5 +31,5 @@
   [Plugin("HeuristicLab.Hive.Engine-3.2")]
   [PluginFile("HeuristicLab.Hive.Engine-3.2.dll", PluginFileType.Assembly)]
-  [PluginDependency("HeuristicLab.Common-3.2")]
+  [PluginDependency("HeuristicLab.Common","3.2.0.0")]
   [PluginDependency("HeuristicLab.Core-3.2")]
   [PluginDependency("HeuristicLab.Data-3.2")]
@@ -38,5 +38,5 @@
   [PluginDependency("HeuristicLab.Hive.JobBase-3.2")]
   [PluginDependency("HeuristicLab.SequentialEngine-3.2")]
-  [PluginDependency("HeuristicLab.Tracing-3.2")]
+  [PluginDependency("HeuristicLab.Tracing","3.2.0.0")]
   public class HeuristicLabHiveEnginePlugin : PluginBase {
   }
Index: /trunk/sources/HeuristicLab.LinearRegression/3.2/HeuristicLabLinearRegressionPlugin.cs
===================================================================
--- /trunk/sources/HeuristicLab.LinearRegression/3.2/HeuristicLabLinearRegressionPlugin.cs	(revision 2757)
+++ /trunk/sources/HeuristicLab.LinearRegression/3.2/HeuristicLabLinearRegressionPlugin.cs	(revision 2758)
@@ -28,5 +28,5 @@
   [PluginFile("HeuristicLab.LinearRegression-3.2.dll", PluginFileType.Assembly)]
   [PluginDependency("HeuristicLab.ALGLIB-2.1.2.2591")]
-  [PluginDependency("HeuristicLab.Common-3.2")]
+  [PluginDependency("HeuristicLab.Common","3.2.0.0")]
   [PluginDependency("HeuristicLab.Core-3.2")]
   [PluginDependency("HeuristicLab.Data-3.2")]
Index: /trunk/sources/HeuristicLab.Logging/3.2/HeuristicLabLoggingPlugin.cs
===================================================================
--- /trunk/sources/HeuristicLab.Logging/3.2/HeuristicLabLoggingPlugin.cs	(revision 2757)
+++ /trunk/sources/HeuristicLab.Logging/3.2/HeuristicLabLoggingPlugin.cs	(revision 2758)
@@ -33,5 +33,5 @@
   [PluginDependency("HeuristicLab.Charting-3.2")]
   [PluginDependency("HeuristicLab.Charting.Data-3.2")]
-  [PluginDependency("HeuristicLab.Common-3.2")]
+  [PluginDependency("HeuristicLab.Common","3.2.0.0")]
   [PluginDependency("HeuristicLab.Core-3.2")]
   [PluginDependency("HeuristicLab.Data-3.2")]
Index: /trunk/sources/HeuristicLab.Modeling/3.2/HeuristicLabModelingPlugin.cs
===================================================================
--- /trunk/sources/HeuristicLab.Modeling/3.2/HeuristicLabModelingPlugin.cs	(revision 2757)
+++ /trunk/sources/HeuristicLab.Modeling/3.2/HeuristicLabModelingPlugin.cs	(revision 2758)
@@ -29,5 +29,5 @@
   [PluginFile("HeuristicLab.Modeling-3.2.dll", PluginFileType.Assembly)]
   [PluginDependency("HeuristicLab.ALGLIB-2.1.2.2591")]
-  [PluginDependency("HeuristicLab.Common-3.2")]
+  [PluginDependency("HeuristicLab.Common","3.2.0.0")]
   [PluginDependency("HeuristicLab.Core-3.2")]
   [PluginDependency("HeuristicLab.Data-3.2")]
Index: /trunk/sources/HeuristicLab.SA/3.2/HeuristicLabSAPlugin.cs
===================================================================
--- /trunk/sources/HeuristicLab.SA/3.2/HeuristicLabSAPlugin.cs	(revision 2757)
+++ /trunk/sources/HeuristicLab.SA/3.2/HeuristicLabSAPlugin.cs	(revision 2758)
@@ -29,5 +29,5 @@
   [Plugin("HeuristicLab.SA-3.2")]
   [PluginFile("HeuristicLab.SA-3.2.dll", PluginFileType.Assembly)]
-  [PluginDependency("HeuristicLab.Common-3.2")]
+  [PluginDependency("HeuristicLab.Common","3.2.0.0")]
   [PluginDependency("HeuristicLab.Core-3.2")]
   [PluginDependency("HeuristicLab.Data-3.2")]
Index: /trunk/sources/HeuristicLab.SGA/3.2/HeuristicLabSGAPlugin.cs
===================================================================
--- /trunk/sources/HeuristicLab.SGA/3.2/HeuristicLabSGAPlugin.cs	(revision 2757)
+++ /trunk/sources/HeuristicLab.SGA/3.2/HeuristicLabSGAPlugin.cs	(revision 2758)
@@ -31,5 +31,5 @@
   [Plugin("HeuristicLab.SGA-3.2")]
   [PluginFile("HeuristicLab.SGA-3.2.dll", PluginFileType.Assembly)]
-  [PluginDependency("HeuristicLab.Common-3.2")]
+  [PluginDependency("HeuristicLab.Common","3.2.0.0")]
   [PluginDependency("HeuristicLab.Core-3.2")]
   [PluginDependency("HeuristicLab.Data-3.2")]
Index: /trunk/sources/HeuristicLab.Selection.Uncertainty/3.2/UncertaintyPlugin.cs
===================================================================
--- /trunk/sources/HeuristicLab.Selection.Uncertainty/3.2/UncertaintyPlugin.cs	(revision 2757)
+++ /trunk/sources/HeuristicLab.Selection.Uncertainty/3.2/UncertaintyPlugin.cs	(revision 2758)
@@ -34,5 +34,5 @@
   [PluginDependency("HeuristicLab.StatisticalAnalysis-3.2")]
   [PluginDependency("HeuristicLab.Random-3.2")]
-  [PluginDependency("HeuristicLab.Tracing-3.2")]
+  [PluginDependency("HeuristicLab.Tracing","3.2.0.0")]
   public class UncertaintyPlugin : PluginBase {
   }