Index: trunk/sources/HeuristicLab.LinearRegression/3.2/HeuristicLab.LinearRegression-3.2.csproj
===================================================================
--- trunk/sources/HeuristicLab.LinearRegression/3.2/HeuristicLab.LinearRegression-3.2.csproj	(revision 2758)
+++ trunk/sources/HeuristicLab.LinearRegression/3.2/HeuristicLab.LinearRegression-3.2.csproj	(revision 2759)
@@ -80,4 +80,5 @@
   </ItemGroup>
   <ItemGroup>
+    <None Include="HeuristicLabLinearRegressionPlugin.cs.frame" />
     <Compile Include="LinearClassification.cs" />
     <Compile Include="HeuristicLabLinearRegressionPlugin.cs" />
@@ -167,5 +168,6 @@
 set Outdir=$(Outdir)
 
-call PreBuildEvent.cmd</PreBuildEvent>
+call PreBuildEvent.cmd
+SubWCRev "%25ProjectDir%25/" "%25ProjectDir%25/HeuristicLabLinearRegressionPlugin.cs.frame" "%25ProjectDir%25/HeuristicLabLinearRegressionPlugin.cs"</PreBuildEvent>
   </PropertyGroup>
 </Project>
Index: trunk/sources/HeuristicLab.LinearRegression/3.2/HeuristicLabLinearRegressionPlugin.cs
===================================================================
--- trunk/sources/HeuristicLab.LinearRegression/3.2/HeuristicLabLinearRegressionPlugin.cs	(revision 2758)
+++ 	(revision )
@@ -1,44 +1,0 @@
-﻿#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-using System;
-using System.Collections.Generic;
-using System.Text;
-using HeuristicLab.PluginInfrastructure;
-
-namespace HeuristicLab.LinearRegression {
-  [Plugin("HeuristicLab.LinearRegression-3.2")]
-  [PluginFile("HeuristicLab.LinearRegression-3.2.dll", PluginFileType.Assembly)]
-  [PluginDependency("HeuristicLab.ALGLIB-2.1.2.2591")]
-  [PluginDependency("HeuristicLab.Common","3.2.0.0")]
-  [PluginDependency("HeuristicLab.Core-3.2")]
-  [PluginDependency("HeuristicLab.Data-3.2")]
-  [PluginDependency("HeuristicLab.DataAnalysis-3.2")]
-  [PluginDependency("HeuristicLab.GP-3.3")]
-  [PluginDependency("HeuristicLab.GP.Interfaces-3.3")]
-  [PluginDependency("HeuristicLab.GP.StructureIdentification-3.3")]
-  [PluginDependency("HeuristicLab.GP.StructureIdentification.Classification-3.3")]
-  [PluginDependency("HeuristicLab.GP.StructureIdentification.TimeSeries-3.3")]
-  [PluginDependency("HeuristicLab.Modeling-3.2")]
-  [PluginDependency("HeuristicLab.Random-3.2")]
-  [PluginDependency("HeuristicLab.SequentialEngine-3.2")]
-  public class HeuristicLabLinearRegression : PluginBase {
-  }
-}
Index: trunk/sources/HeuristicLab.LinearRegression/3.2/HeuristicLabLinearRegressionPlugin.cs.frame
===================================================================
--- trunk/sources/HeuristicLab.LinearRegression/3.2/HeuristicLabLinearRegressionPlugin.cs.frame	(revision 2759)
+++ trunk/sources/HeuristicLab.LinearRegression/3.2/HeuristicLabLinearRegressionPlugin.cs.frame	(revision 2759)
@@ -0,0 +1,44 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+using System;
+using System.Collections.Generic;
+using System.Text;
+using HeuristicLab.PluginInfrastructure;
+
+namespace HeuristicLab.LinearRegression {
+  [Plugin("HeuristicLab.LinearRegression","3.2.0.$WCREV$")]
+  [PluginFile("HeuristicLab.LinearRegression-3.2.dll", PluginFileType.Assembly)]
+  [PluginDependency("HeuristicLab.ALGLIB-2.1.2.2591")]
+  [PluginDependency("HeuristicLab.Common","3.2.0.0")]
+  [PluginDependency("HeuristicLab.Core-3.2")]
+  [PluginDependency("HeuristicLab.Data-3.2")]
+  [PluginDependency("HeuristicLab.DataAnalysis-3.2")]
+  [PluginDependency("HeuristicLab.GP","3.3.0.0")]
+  [PluginDependency("HeuristicLab.GP.Interfaces","3.3.0.0")]
+  [PluginDependency("HeuristicLab.GP.StructureIdentification","3.3.0.0")]
+  [PluginDependency("HeuristicLab.GP.StructureIdentification.Classification","3.3.0.0")]
+  [PluginDependency("HeuristicLab.GP.StructureIdentification.TimeSeries","3.3.0.0")]
+  [PluginDependency("HeuristicLab.Modeling-3.2")]
+  [PluginDependency("HeuristicLab.Random-3.2")]
+  [PluginDependency("HeuristicLab.SequentialEngine-3.2")]
+  public class HeuristicLabLinearRegression : PluginBase {
+  }
+}
Index: trunk/sources/HeuristicLab.LinearRegression/3.2/Properties/AssemblyInfo.frame
===================================================================
--- trunk/sources/HeuristicLab.LinearRegression/3.2/Properties/AssemblyInfo.frame	(revision 2758)
+++ trunk/sources/HeuristicLab.LinearRegression/3.2/Properties/AssemblyInfo.frame	(revision 2759)
@@ -23,5 +23,4 @@
 using System.Runtime.CompilerServices;
 using System.Runtime.InteropServices;
-using HeuristicLab.PluginInfrastructure;
 
 // General Information about an assembly is controlled through the following 
@@ -33,5 +32,5 @@
 [assembly: AssemblyCompany("")]
 [assembly: AssemblyProduct("HeuristicLab")]
-[assembly: AssemblyCopyright("(c) 2002-2008 HEAL")]
+[assembly: AssemblyCopyright("(c) 2002-2010 HEAL")]
 [assembly: AssemblyTrademark("")]
 [assembly: AssemblyCulture("")]
@@ -54,5 +53,4 @@
 // You can specify all the values or you can default the Revision and Build Numbers 
 // by using the '*' as shown below:
-[assembly: AssemblyVersion("3.2.0.$WCREV$")]
+[assembly: AssemblyVersion("3.2.0.0")]
 [assembly: AssemblyFileVersion("3.2.0.$WCREV$")]
-[assembly: AssemblyBuildDate("$WCNOW$")]