Index: trunk/sources/HeuristicLab.MainForm/3.2/ContentAttribute.cs
===================================================================
--- trunk/sources/HeuristicLab.MainForm/3.2/ContentAttribute.cs	(revision 2755)
+++ trunk/sources/HeuristicLab.MainForm/3.2/ContentAttribute.cs	(revision 2761)
@@ -24,15 +24,15 @@
 using System.Linq;
 using System.Text;
+using System.Reflection;
 
 namespace HeuristicLab.MainForm {
   [AttributeUsage(AttributeTargets.Class, AllowMultiple = true, Inherited = false)]
-  public class ContentAttribute : Attribute {
-    private Type type;
-    public ContentAttribute(Type type) {
-      this.type = type;
+  public sealed class ContentAttribute : Attribute {
+    public ContentAttribute(Type contentType) {
+      this.contentType = contentType;
     }
 
-    public ContentAttribute(Type type, bool isDefaultView)
-      : this(type) {
+    public ContentAttribute(Type contentType, bool isDefaultView)
+      : this(contentType) {
       this.isDefaultView = isDefaultView;
     }
@@ -44,12 +44,17 @@
     }
 
-    public static bool HasContentAttribute(Type viewType) {
+    private Type contentType;
+    public Type ContentType {
+      get { return this.contentType; }
+    }
+
+    public static bool HasContentAttribute(MemberInfo viewType) {
       ContentAttribute[] attributes = (ContentAttribute[])viewType.GetCustomAttributes(typeof(ContentAttribute), false);
       return attributes.Length != 0;
     }
 
-    public static bool CanViewType(Type viewType, Type content) {
+    public static bool CanViewType(MemberInfo viewType, Type content) {
       ContentAttribute[] attributes = (ContentAttribute[])viewType.GetCustomAttributes(typeof(ContentAttribute), false);
-      return attributes.Any(a => content.IsAssignableTo(a.type));
+      return attributes.Any(a => content.IsAssignableTo(a.contentType));
     }
 
@@ -58,5 +63,5 @@
       return from a in attributes
              where a.isDefaultView
-             select a.type;
+             select a.contentType;
     }
 
@@ -64,5 +69,5 @@
       ContentAttribute[] attributes = (ContentAttribute[])viewType.GetCustomAttributes(typeof(ContentAttribute), false);
       return from a in attributes
-             select a.type;
+             select a.contentType;
     }
   }
Index: trunk/sources/HeuristicLab.MainForm/3.2/Interfaces/IPositionableUserInterfaceItem.cs
===================================================================
--- trunk/sources/HeuristicLab.MainForm/3.2/Interfaces/IPositionableUserInterfaceItem.cs	(revision 2755)
+++ trunk/sources/HeuristicLab.MainForm/3.2/Interfaces/IPositionableUserInterfaceItem.cs	(revision 2761)
@@ -26,5 +26,5 @@
 
 namespace HeuristicLab.MainForm {
-  public interface IPositionableUserInterfaceItem :IUserInterfaceItem {
+  public interface IPositionableUserInterfaceItem : IUserInterfaceItem {
     int Position { get; }
     IEnumerable<string> Structure { get; }
Index: trunk/sources/HeuristicLab.MainForm/3.2/MainFormManager.cs
===================================================================
--- trunk/sources/HeuristicLab.MainForm/3.2/MainFormManager.cs	(revision 2755)
+++ trunk/sources/HeuristicLab.MainForm/3.2/MainFormManager.cs	(revision 2761)
@@ -28,6 +28,4 @@
 
 namespace HeuristicLab.MainForm {
-  class StringDict<T> : Dictionary<string, T> {
-  }
   public static class MainFormManager {
     private static object locker;
@@ -38,16 +36,17 @@
     static MainFormManager() {
       locker = new object();
+      mainform = null;
       views = new HashSet<Type>();
       defaultViews = new Dictionary<Type, Type>();
     }
 
-    public static void RegisterMainForm(IMainForm mainform) {
+    public static void RegisterMainForm(IMainForm mainForm) {
       lock (locker) {
         if (MainFormManager.mainform != null)
           throw new ArgumentException("A mainform was already associated with the mainform manager.");
-        if (mainform == null)
+        if (mainForm == null)
           throw new ArgumentException("Could not associate null as a mainform in the mainform manager.");
 
-        MainFormManager.mainform = mainform;
+        MainFormManager.mainform = mainForm;
         IEnumerable<Type> types =
           from t in ApplicationManager.Manager.GetTypes(typeof(IView))
@@ -86,6 +85,6 @@
     }
 
-    public static bool ViewCanViewObject(IView view, object o) {
-      return ContentAttribute.CanViewType(view.GetType(), o.GetType());
+    public static bool ViewCanViewObject(IView view, object content) {
+      return ContentAttribute.CanViewType(view.GetType(), content.GetType());
     }
 
@@ -113,14 +112,14 @@
       //more than one default view for implemented interfaces are found
       if (temp.Count > 1)
-        throw new Exception("Could not determine which is the default view for type " + contentType.ToString() + ". Because more than one implemented interfaces have a default view.");
+        throw new InvalidOperationException("Could not determine which is the default view for type " + contentType.ToString() + ". Because more than one implemented interfaces have a default view.");
       return null;
     }
 
-    public static IView CreateDefaultView(object objectToView) {
-      Type t = GetDefaultViewType(objectToView.GetType());
+    public static IView CreateDefaultView(object content) {
+      Type t = GetDefaultViewType(content.GetType());
       if (t == null)
         return null;
 
-      return (IView)Activator.CreateInstance(t, objectToView);
+      return (IView)Activator.CreateInstance(t, content);
     }
 
@@ -134,5 +133,5 @@
     }
 
-    public static IView CreateView(Type viewType, object objectToView) {
+    public static IView CreateView(Type viewType, object content) {
       if (!typeof(IView).IsAssignableFrom(viewType))
         throw new ArgumentException("View can not be created becaues given type " + viewType.ToString() + " is not of type IView.");
@@ -140,5 +139,5 @@
         throw new ArgumentException("View can not be created becaues given type " + viewType.ToString() + " is a generic type definition.");
 
-      return (IView)Activator.CreateInstance(viewType, objectToView);
+      return (IView)Activator.CreateInstance(viewType, content);
     }
 
Index: trunk/sources/HeuristicLab.MainForm/3.2/TypeExtension.cs
===================================================================
--- trunk/sources/HeuristicLab.MainForm/3.2/TypeExtension.cs	(revision 2755)
+++ trunk/sources/HeuristicLab.MainForm/3.2/TypeExtension.cs	(revision 2761)
@@ -78,9 +78,4 @@
       return true;
     }
-
-    internal static Type[] ExtractGenericTypeArguments(this Type type, Type other) {
-      Type[] types = new Type[0];
-      return types;
-    }
   }
 }